/* $Id: MapInfo.java,v 1.5 1996/03/28 08:46:15 djun Exp $

   File: MapInfo.java

   Author: Djun M. Kim
   Copyright (c) 1996 Djun M. Kim.  All rights reserved.

*/

import java.awt.image.*;
import java.awt.*;
import java.lang.Thread;
import java.applet.Applet;
import java.net.URL;
import Map;
import MapError;

public class MapInfo extends java.applet.Applet {

    Map   	map    		= new Map();

    public  MapPanel mapview;
    public  CtrlPanel ctrlview;

    TitlePanel 	title;
    InfoPanel 	infoview;

    public MapError 	error_handler = new MapError();


    public void init() {
	initMapImage();
	initPanels();
    	map.initMapLocations();
    }


    // Initialize the map image
    public boolean initMapImage() {
	map.mapimage = getImage(getDocumentBase(), map.getImageSrc());
	return true;
    }

    public void setInfo (String s) {
      infoview.display(s);
    }

    private MainPanel mainpanel;

    private void initPanels() {
	mapview = new MapPanel(this);
 	ctrlview = new CtrlPanel(this);
  	title = new TitlePanel(this);
  	infoview = new InfoPanel(this);
	setLayout(new GridLayout(1,1));
	mainpanel = new MainPanel(this);	
    }

    public String getAppletInfo() {
	return("MapInfo version 1.0; Copyright (c) 1996 Djun M. Kim");
    }
}

class MainPanel extends gridPanel {
    // Location search display panel

    int REMN = GridBagConstraints.REMAINDER;

    Panel p = new Panel();

    MainPanel(MapInfo parent) {
	super(parent);
	//	   Panel		gridx	gridy	Weightx Weighty GridW   GridH
	make_panel(parent.title, 	1,	1,	1.0,	0.0,	REMN,	1);
	make_panel(parent.mapview,	1,	2,	2.0,	1.0,	1,	REMN);
	make_panel(parent.infoview,	3,	2,	1.0,	0.0,	1,	1); 
	make_panel(parent.ctrlview,	3,	3,	1.0,	1.0,	1,	REMN);
    }

    // Event handler
    public boolean action(Event evt, Object arg) {
	    return false;  
    }
}




