##############################################################################
#
#  Copyright (c) 1996 by Dow Jones and Company, Inc.
#
#  Applet.mak
#
#       Makefile for Personal Journal applets.
#
#  Authors:
#
#      rphall   Rick Hall
#
#  Version Ident:
#
#      $Header: /PjJavaClient/src/pj/applet/Applet.mak 3     1/30/96 6:13p Rphall $
#
#  History:
#
#      09-Jan-96    rphall  Initial creation
#
##############################################################################

# REQUIRED: define where master makefiles can be found.
# (Make definition conditional so that it can be overridden on a command line.)
!IF "$(JAVAMAKEDIR)" == ""
JAVAMAKEDIR=.\..\..
!ENDIF
!IF "$(CFG)" == ""
CFG=Java Debug
!ENDIF
!IF "$(JAVACLASSDIR)" == ""
JAVACLASSDIR=.\classes
!ENDIF
!IF "$(JAVADOCDIR)" == ""
JAVADOCDIR=.\apidocs
!ENDIF

# Include default macro definitions and generalized rules
!INCLUDE $(JAVAMAKEDIR)\defaults.mak

# List your classes here, one per line, with a backslash for continuation
CLASSES=DownloadThread.class \
        PjJava.class \
        PjLauncher.class

# List the classes you want documented, one per line, with backslashes
APIDOCS=Packages-pj.applet.html \
        pj.applet.DownloadThread.html \
        pj.applet.PjJava.html \
        pj.applet.PjLauncher.html

# The default target for the build. (The first target is the project default.)
binary : $(JAVACLASSDIR) $(CLASSES)
        for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)

documentation : $(JAVADOCDIR) $(JAVADOCDIR)/images $(APIDOCS)
        for %f in ($(APIDOCS)) do copy %f $(JAVADOCDIR)

all : binary documentation

# Include other targets
!INCLUDE $(JAVAMAKEDIR)\dtargets.mak

# List dependencies here (particularly private class dependencies)

PjJava.class                  : PjJava.java \
                                ..\awt\PjFinals.class \
                                DownloadThread.class

PjLauncher.class              : PjLauncher.java \
                                PjJava.class

DownloadThread.class          : DownloadThread.java

pj.applet.DownloadThread.html : DownloadThread.html

pj.applet.PjJava.html         : PjJava.html

pj.applet.PjLauncher.html     : PjLauncher.html
