##############################################################################
#
#  Copyright (c) 1996 by Dow Jones and Company, Inc.
#
#  Awt.mak
#
#      Makefile for Personal Journal AWT subsystem.
#
#  Authors:
#
#      rphall   Rick Hall
#
#  Version Ident:
#
#      $Header: /PjJavaClient/src/pj/awt/Awt.mak 29    2/13/96 10:22p Rphall $
#
#  History:
#
#      0.00 28-Dec-95   rphall  initial creation
#
##############################################################################

# REQUIRED: define where master makefiles can be found.
# (Make definition conditional so that it can be overridden on a command line.)
!IF "$(JAVAMAKEDIR)" == ""
JAVAMAKEDIR=.\..\..
!ENDIF
!IF "$(CFG)" == ""
CFG=Java Debug
!ENDIF
!IF "$(JAVACLASSDIR)" == ""
JAVACLASSDIR=.\classes
!ENDIF
!IF "$(JAVADOCDIR)" == ""
JAVADOCDIR=.\apidocs
!ENDIF

# Include default macro definitions and generalized rules
!INCLUDE $(JAVAMAKEDIR)\defaults.mak

# Java binaries
CLASSES=AboutBoxLayout.class \
        AboutDialog.class \
        ArrayFormatter.class   \
        BullOrBear.class       \
        Chart.class            \
        Column.class       \
        ColumnAndButtons.class       \
        ColumnSingleView.class       \
        DeferPage.class      \
        Divider.class      \
        DividerView.class  \
        DJChart.class      \
        DogEar.class       \
        GifCanvas.class    \
        HeadlineView.class \
        HeadlineSection.class  \
        HighlightFilter.class  \
        ImageMapArea.class  \
        LineTextBox.class   \
        LineTextBoxError.class   \
        LineThroughPanel.class   \
        MainFrame.class     \
        MarketSection.class \
        MrkViewStkIdx.class \
        MrkViewExTrs.class  \
        MrkViewWrap.class   \
        NameArea.class  \
        Notebook.class  \
        Notebook3DBorder.class \
        NotebookTab.class \
        NotebookTabBar.class \
        ObsvrLabel.class \
        Page.class      \
        PageStack.class \
        PageView.class  \
        Panel3D.class \
        Panel3DLayout.class \
        PaperView.class \
        PjAds.class     \
        PjAdSpec.class  \
        PjAdView.class  \
        PjAdViewLayout.class \
        PjBtnLbLayout.class \
        PjButtonLayout.class   \
        PjHdlViewLayout.class  \
        PjFinals.class   \
        PjFrame.class          \
        PjImages.class     \
        PjListLayout.class \
        PjMenuBar.class \
        PjMenuItem.class \
        PjNbSpec.class  \
        PjPageSpec.class\
        PjStr.class     \
        PjTabNotebook.class \
        PjTicker.class  \
        PortView.class  \
        Section.class   \
        SectionView.class  \
        SportsViewScores.class \
        SportsViewHighlights.class \
        SportsSection.class   \
        StatusBar.class   \
        StoryFormatter.class  \
        StoryList.class       \
        StringTabSpec.class   \
        Tab.class     \
        Tab3D.class \
        TabBar.class  \
        TabBarLayout.class \
        TabNotebook.class \
        TabNbPanelLayout.class \
        TabSpec.class \
        TextCanvas.class \
        TextBox.class \
        Ticker.class \
        TitleList.class \
        TitleListLayout.class \
        ViewAndButtons.class  \
        WeatherColumn.class   \
        WeatherFormatter.class\
        WeatherImageMap.class \
        WeatherSection.class  \
        WeatherView.class

# Documentation
APIDOCS=Packages-pj.awt.html            \
        pj.awt.AboutDialog.html         \
        pj.awt.ArrayFormatter.html      \
        pj.awt.BullOrBear.html          \
        pj.awt.Chart.html               \
        pj.awt.Column.html              \
        pj.awt.ColumnAndButtons.html    \
        pj.awt.ColumnSingleView.html    \
        pj.awt.DeferPage.html           \
        pj.awt.Divider.html             \
        pj.awt.DividerView.html         \
        pj.awt.DJChart.html             \
        pj.awt.DogEar.html              \
        pj.awt.GifCanvas.html           \
        pj.awt.HeadlineView.html        \
        pj.awt.HeadlineSection.html     \
        pj.awt.HighlightFilter.html     \
        pj.awt.ImageMapArea.html        \
        pj.awt.Line3D.html              \
        pj.awt.LineTextBox.html         \
        pj.awt.LineTextBoxError.html    \
        pj.awt.MainFrame.html           \
        pj.awt.MarketSection.html       \
        pj.awt.NameArea.html            \
        pj.awt.Notebook.html            \
        pj.awt.Notebook3DBorder.html    \
        pj.awt.NotebookTab.html         \
        pj.awt.NotebookTabBar.html      \
        pj.awt.ObsvrLabel.html          \
        pj.awt.Page.html                \
        pj.awt.PageStack.html           \
        pj.awt.PageView.html            \
        pj.awt.Panel3D.html             \
        pj.awt.Panel3DLayout.html       \
        pj.awt.PaperView.html           \
        pj.awt.PjAds.html               \
        pj.awt.PjAdSpec.html            \
        pj.awt.PjAdView.html            \
        pj.awt.PjAdViewLayout.html      \
        pj.awt.PjBtnLbLayout.html       \
        pj.awt.PjButtonLayout.html      \
        pj.awt.PjFinals.html            \
        pj.awt.PjFrame.html             \
        pj.awt.PjHdlViewLayout.html     \
        pj.awt.PjImages.html            \
        pj.awt.PjListLayout.html        \
        pj.awt.PjMenuBar.html           \
        pj.awt.PjMenuItem.html          \
        pj.awt.PjNbSpec.html            \
        pj.awt.PjPageSpec.html          \
        pj.awt.PjStr.html               \
        pj.awt.PjTabNotebook.html       \
        pj.awt.PjTicker.html            \
        pj.awt.PortView.html            \
        pj.awt.Section.html             \
        pj.awt.SectionView.html         \
        pj.awt.SportsViewScores.html    \
        pj.awt.SportsViewHighlights.html\
        pj.awt.SportsSection.html       \
        pj.awt.StatusBar.html           \
        pj.awt.StoryFormatter.html      \
        pj.awt.StoryList.html           \
        pj.awt.StringTabSpec.html       \
        pj.awt.Tab.html                 \
        pj.awt.Tab3D.html               \
        pj.awt.TabBar.html              \
        pj.awt.TabBarLayout.html        \
        pj.awt.TabNbPanelLayout.html    \
        pj.awt.TabNotebook.html         \
        pj.awt.TabSpec.html             \
        pj.awt.TextBox.html             \
        pj.awt.TextCanvas.html          \
        pj.awt.TitleList.html           \
        pj.awt.Ticker.html              \
        pj.awt.WeatherImageMap.html     \
        pj.awt.WeatherView.html         \
        pj.awt.WeatherSection.html

# The targets for the build. (The first target is the project default.)
binary : $(JAVACLASSDIR) $(CLASSES)
        for %f in ($(CLASSES)) do copy %f $(JAVACLASSDIR)

documentation : $(JAVADOCDIR) $(JAVADOCDIR)/images $(APIDOCS)
        for %f in ($(APIDOCS)) do copy %f $(JAVADOCDIR)

all: binary documentation

# Include other targets
!INCLUDE $(JAVAMAKEDIR)\dtargets.mak

# List dependencies here (particularly private class dependencies)
AboutBoxLayout.class    : AboutDialog.class

AboutDialog.class       : AboutDialog.java \
                          GifCanvas.class \
                          Panel3D.class \
                          PjImages.class \
                          TextCanvas.class

ArrayFormatter.class        : ArrayFormatter.java \
                              StoryFormatter.class

BullOrBear.class        : BullOrBear.java \
                             GifCanvas.class


Chart.class                 : Chart.java\
                              DJChart.class \
                              PageView.class

Column.class                : Column.java \
                              PageView.class \
                              StoryFormatter.class \
                              TextBox.class \
                              ..\io\PaperSection.class

ColumnAndButtons.class      : HeadlineSection.java

ColumnSingleView.class      : ColumnSingleView.java \
                              Column.class

DeferPage.class             : DeferPage.java \
                              Page.class

Divider.class               : Divider.java \
                              Page.class \
                              TabSpec.class

DividerView.class           : DividerView.java \
                              Divider.java \
                              PaperView.java

DJChart.class               : DJChart.java

DogEar.class                : DogEar.java \
                              Notebook.class \
                              PjImages.class

GifCanvas.class             : GifCanvas.java

HeadlineView.class          : HeadlineView.java \
                              Column.class \
                              ObsvrLabel.class \
                              PjHdlViewLayout.class \
                              PjNbSpec.class \
                              PjFinals.class \
                              StoryList.class

HeadlineSection.class       : HeadlineSection.java \
                              Column.class \
                              ColumnSingleView.class \
                              DeferPage.class \
                              HeadlineView.class \
                              PjPageSpec.class \
                              PjStr.class \
                              SectionView.class \
                              StoryList.class

HighlightFilter.class       : WeatherImageMap.java

ImageMapArea.class          : WeatherImageMap.class

LineTextBox.class           : TextBox.java

LineTextBoxError.class      : TextBox.java

LineThroughPanel.class      : HeadlineView.java

MainFrame.class             : MainFrame.java

MarketSection.class         : MarketSection.java \
                              ArrayFormatter.class \
                              BullOrBear.class \
                              Chart.class \
                              Column.class \
                              PageView.class \
                              PjButtonLayout.class \
                              PjListLayout.class \
                              PjPageSpec.class \
                              PjFinals.class \
                              PjStr.class \
                              SectionView.class

MrkViewStkIdx.class         : MarketSection.java

MrkViewExTrs.class          : MarketSection.java

MrkViewWrap.class           : MarketSection.java

NameArea.class              : WeatherImageMap.java

Notebook.class              : Notebook.java \
                              Divider.class \
                              Page.class

Notebook3DBorder.class      : TabNotebook.java

NotebookTab.class           : NotebookTabBar.java \
                              StringTabSpec.class \
                              Tab.class

NotebookTabBar.class        : NotebookTabBar.java \
                              Notebook.class \
                              PjFinals.class \
                              StringTabSpec.class \
                              TabBar.class \
                              TabSpec.class

ObsvrLabel.class            : ObsvrLabel.java \
                              ..\io\DownloadProgressNotification.class

Page.class                  : Page.java

PageView.class              : PageView.java \
                              Page.class    \
                              PaperView.class

PageStack.class             : PageStack.java \
                              Page.class

Panel3D.class               : Panel3D.java

Panel3DLayout.class         : Panel3D.java

PaperView.class             : PaperView.java

PjAds.class                 : PjAds.java \
                              PjAdSpec.class

PjAdSpec.class              : PjAdSpec.java

PjAdView.class              : PjAdView.java \
                              GifCanvas.class \
                              LineTextBox.class \
                              PageView.class \
                              PjAdSpec.class \
                              PjAdViewLayout.class

PjAdViewLayout.class        : PjAdViewLayout.java \
                              PjFinals.class \
                              ..\applet\PjLauncher.class

PjBtnLbLayout.class         : PjBtnLbLayout.java \
                              PjFinals.class

PjButtonLayout.class        : PjButtonLayout.java \
                              PjFinals.class

PjFinals.class              : PjFinals.java

PjFrame.class               : PjFrame.java \
                              AboutDialog.class

PjHdlViewLayout.class       : PjHdlViewLayout.java \
                              TitleList.class

PjImages.class              : PjImages.java

PjListLayout.class          : PjListLayout.java \
                              PjFinals.class

PjMenuBar.class             : PjFrame.java
PjMenuItem.class            : PjFrame.java

PjNbSpec.class              : PjNbSpec.java \
                              Notebook.class \
                              PjPageSpec.class \
                              TabSpec.class

PjPageSpec.class            : PjPageSpec.java \
                              TabSpec.class

PjStr.class                 : PjNbSpec.java

PjTabNotebook.class         : PjTabNotebook.java \
                              DividerView.class \
                              DogEar.class \
                              HeadlineSection.class \
                              MarketSection.class \
                              PageView.class \
                              Panel3D.class \
                              PaperView.class \
                              PjAds.class \
                              PjFrame.class \
                              PjImages.class \
                              PjNbSpec.class \
                              PjTicker.class \
                              SportsSection.class \
                              StatusBar.class \
                              StoryList.class \
                              TabNotebook.class \
                              WeatherSection.class \
                              ..\util\LocalDateTime.class

PjTicker.class              : PjTicker.java \
                              Ticker.class

PortView.class              : PortView.java \
                              ArrayFormatter.class \
                              Column.class \
                              PjNbSpec.class \
                              PjListLayout.class \
                              PjFinals.class

Section.class               : Section.java \
                              Divider.class \
                              Notebook.class \
                              Page.class \
                              PageStack.class \
                              TabSpec.class

SectionView.class           : SectionView.java \
                              PaperView.class \
                              Section.class \
                              TabSpec.class

SportsViewScores.class      : SportsSection.java

SportsViewHighlights.class  : SportsSection.java

SportsSection.class         : SportsSection.java \
                              Column.class \
                              PageView.class \
                              PjListLayout.class \
                              PjPageSpec.class \
                              PjFinals.class \
                              PjStr.class \
                              SectionView.class

StatusBar.class             : StatusBar.java \
                              ..\io\PaperSection.class

StoryFormatter.class        : StoryFormatter.java

StoryList.class             : StoryList.java \
                              PageView.class \
                              TitleList.class

StringTabSpec.class         : StringTabSpec.java \
                              TabSpec.class

Tab.class                   : Tab.java

Tab3D.class                 : NotebookTabBar.java

TabBar.class                : TabBar.java \
                              TabSpec.class

TabBarLayout.class          : NotebookTabBar.java

TabNbPanelLayout.class      : TabNotebook.java

TabNotebook.class           : TabNotebook.java \
                              Divider.class \
                              Notebook.class \
                              NotebookTabBar.class \
                              Page.class \
                              PageStack.class \
                              PjFinals.class \
                              StringTabSpec.class

TabSpec.class               : TabSpec.java

TextBox.class               : TextBox.java \
                              Panel3D.class \
                              PjFinals.class

TextCanvas.class            : TextCanvas.java \
                              PjFinals.class

Ticker.class                : Ticker.java

TitleList.class             : TitleList.java \
                              PjFinals.class

ViewAndButtons.class        : MarketSection.java

WeatherColumn.class         : WeatherSection.java \
                              Column.class

WeatherFormatter.class      : WeatherSection.java \
                              ArrayFormatter.class

WeatherImageMap.class       : WeatherImageMap.java \
                              PjTabNotebook.class \
                              StatusBar.class

WeatherView.class           : WeatherView.java \
                              ArrayFormatter.class \
                              PageView.class \
                              PjAdSpec.class \
                              PjAdView.class \
                              TextBox.class

WeatherSection.class        : WeatherSection.java \
                              Column.class \
                              WeatherView.class \
                              PjPageSpec.class \
                              PjFinals.class \
                              PjStr.class \
                              SectionView.class


pj.awt.AboutDialog.html         :  AboutDialog.html
pj.awt.ArrayFormatter.html      :  ArrayFormatter.html
pj.awt.BullOrBear.html          :  BullOrBear.html
pj.awt.Chart.html               :  Chart.html
pj.awt.Column.html              :  Column.html
pj.awt.ColumnAndButtons.html    :  Column.html
pj.awt.DeferPage.html           :  DeferPage.html
pj.awt.Divider.html             :  Divider.html
pj.awt.DividerView.html         :  DividerView.html
pj.awt.DJChart.html             :  DJChart.html
pj.awt.DogEar.html              :  DogEar.html
pj.awt.GifCanvas.html           :  GifCanvas.html
pj.awt.HeadlineView.html        :  HeadlineView.html
pj.awt.HeadlineSection.html     :  HeadlineSection.html
pj.awt.HighlightFilter.html     :  HighlightFilter.html
pj.awt.ImageMapArea.html        :  ImageMapArea.html
pj.awt.Line3D.html              :  Line3D.html
pj.awt.LineTextBox.html         :  LineTextBox.html
pj.awt.LineTextBoxError.html    :  LineTextBoxError.html
pj.awt.MainFrame.html           :  MainFrame.html
pj.awt.MarketSection.html       :  MarketSection.html
pj.awt.NameArea.html            :  NameArea.html
pj.awt.Notebook.html            :  Notebook.html
pj.awt.Notebook3DBorder.html    :  Notebook3DBorder.html
pj.awt.NotebookTab.html         :  NotebookTab.html
pj.awt.NotebookTabBar.html      :  NotebookTabBar.html
pj.awt.ObsvrLabel.html          :  ObsvrLabel.html
pj.awt.Page.html                :  Page.html
pj.awt.PageStack.html           :  PageStack.html
pj.awt.PageView.html            :  PageView.html
pj.awt.Panel3D.html             :  Panel3D.html
pj.awt.Panel3DLayout.html       :  Panel3DLayout.html
pj.awt.PaperView.html           :  PaperView.html
pj.awt.PjAds.html               :  PjAds.html
pj.awt.PjAdSpec.html            :  PjAdSpec.html
pj.awt.PjAdView.html            :  PjAdView.html
pj.awt.PjAdViewLayout.html      :  PjAdViewLayout.html
pj.awt.PjBtnLbLayout.html       :  PjBtnLbLayout.html
pj.awt.PjButtonLayout.html      :  PjButtonLayout.html
pj.awt.PjFinals.html            :  PjFinals.html
pj.awt.PjFrame.html             :  PjFrame.html
pj.awt.PjHdlViewLayout.html     :  PjHdlViewLayout.html
pj.awt.PjImages.html            :  PjImages.html
pj.awt.PjListLayout.html        :  PjListLayout.html
pj.awt.PjMenuBar.html           :  PjMenuBar.html
pj.awt.PjMenuItem.html          :  PjMenuItem.html
pj.awt.PjNbSpec.html            :  PjNbSpec.html
pj.awt.PjPageSpec.html          :  PjPageSpec.html
pj.awt.PjStr.html               :  PjStr.html
pj.awt.PjTabNotebook.html       :  PjTabNotebook.html
pj.awt.PjTicker.html            :  PjTicker.html
pj.awt.PortView.html            :  PortView.html
pj.awt.Section.html             :  Section.html
pj.awt.SectionView.html         :  SectionView.html
pj.awt.SportsViewScores.html    :  SportsViewScores.html
pj.awt.SportsViewHighlights.html:  SportsViewHighlights.html
pj.awt.SportsSection.html       :  SportsSection.html
pj.awt.StatusBar.html           :  StatusBar.html
pj.awt.StoryFormatter.html      :  StoryFormatter.html
pj.awt.StoryList.html           :  StoryList.html
pj.awt.StringTabSpec.html       :  StringTabSpec.html
pj.awt.Tab.html                 :  Tab.html
pj.awt.Tab3D.html               :  Tab3D.html
pj.awt.TabBar.html              :  TabBar.html
pj.awt.TabBarLayout.html        :  TabBarLayout.html
pj.awt.TabNbPanelLayout.html    :  TabNbPanelLayout.html
pj.awt.TabNotebook.html         :  TabNotebook.html
pj.awt.TabSpec.html             :  TabSpec.html
pj.awt.TextBox.html             :  TextBox.html
pj.awt.TextCanvas.html          :  TextCanvas.html
pj.awt.TitleList.html           :  TitleList.html
pj.awt.Ticker.html              :  Ticker.html
pj.awt.WeatherImageMap.html     :  WeatherImageMap.html
pj.awt.WeatherView.html         :  WeatherView.html
pj.awt.WeatherSection.html      :  WeatherSection.html
