/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.


    @(#)PageView.java  0.00 01-Jan-96

        A Page that implements PaperView.

    Authors:

        rphall   Rick Hall

    Version Ident:

        $Header$

    History:

        0.00 01-Jan-96  rphall      Initial Creation
        0.01  1-Mar-96  Ted S.      Obsoleted this class, because Page 
                                       implements PaperView().  For now
                                       this is just a pass through.  But, 
                                       it should be removed.  So, don't use
                                       it if you are writing new code.

---------------------------------------------------------------------------*/

package pj.awt;

import pj.util.Nameable;

import java.awt.Panel;

/**
 * A Page that implements PaperView.
 *
 * @version 0.00 01-Jan-96
 * @author  rphall
*/
//public abstract class PageView extends Page 
public class PageView extends Page
    {

    // --- Public constructors

    /**
     * Construct a PageView with a given name.
     * @param name  The name for a pageview
    */
    public PageView(String name)
        { 
        super(name); 
        }

    /**
     * Construct a PageView with a null name.
    */
    public PageView()
        { 
        this(null); 
        }

    // --- Public operations

    /**
     * @return The number of views in an implementation instance.
    */
    public int countViews() 
        { 
        System.out.println( "PageView :: countViews - calling Super " );
        return super.countViews(); 
        }
 
    /**
     * Make the first view the current view.
    */
    public void firstView() 
        {
        super.firstView();
        }

    /**
     * Make the next view (after the current view) the current view.
    */
    public boolean nextView() 
        {
        return super.nextView();
        }

    /**
     * Make the last view the current view.
    */
    public void lastView() 
        {
        super.lastView();
        }

    /**
     * Make the previous view (before current view) the current view.
    */
    public boolean previousView() 
        {
        return super.previousView();
        }

    
     
    /**
     * Make a specific view the current view.
     * @param idx The index of the view to display.
    */
    public void view(int idx) 
        {
        super.view( idx );
        }

    } // PageView
