/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.


    @(#)PjPageSpec.java  0.00 05-Jan-96

        A specification for a page in Personal Journal notebook.


    Authors:

        rphall      Rick Hall


    Version Ident:

        $Header$


    History:

        05-Jan-96    rphall      Initial Creation


---------------------------------------------------------------------------*/

package pj.awt;

import pj.awt.TabSpec;

import java.lang.Object;
import java.lang.String;

/**
 * A specification for a page in Personal Journal notebook.
 * @version 0.00, 05-Jan-96
 * @author 	Rick Hall
 */
public class PjPageSpec
    {

    // --- Instance variables

    /** Page name */
    public String strPageName;

    /** Tab specification if page is a divider */
    public TabSpec tabspec;

    /** View specification */
    public Object viewspec;

    // --- Public constructors

    public PjPageSpec(
            String  pageName,
            TabSpec tabSpec,
            Object  viewSpec)
        {
        strPageName = pageName;
        tabspec = tabSpec;
        viewspec = viewSpec;
        }

    public PjPageSpec()
        { 
        this(null,null,null); 
        }

    } // PjPageSpec
