/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.


    StoryFormatter.java  0.00 05-Feb-96

        An interface for objects that format PaperStories into Strings.

    Authors:

        rphall   Rick Hall

    Version Ident:

        $Header: /PjJavaClient/src/pj/awt/StoryFormatter.java 2     2/05/96 6:50p Rphall $

    History:

        0.00 05-Feb-96  rphall   Initial Creation

---------------------------------------------------------------------------*/

package pj.awt;

import pj.io.PaperStory;

/**
 * An interface for objects that format PaperStories into Strings.
 * StoryFormatters are typically used by Columns.
 *
 * @see        pj.io.PaperStory
 * @see        pj.awt.Column
 * @version    0.00 05-Feb-96
 * @author     rphall
*/
public interface StoryFormatter
    {

    // --- Public operations

    /**
     * @param story The PaperStory to format.
     * @return A String representation of the story.
    */
    public String formatToString(PaperStory story);

    }; // StoryFormatter
