/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.



    @(#)DownloadProgressNotification.java   0.00 20-Dec-95

        A token passed to an observer of a StoryContainer whenever a new
        story is added.

    Authors:

        jlee      James Lee


    Version Ident:

        $Header$


    History:

        21-mar-96    jlee      Initial Creation

---------------------------------------------------------------------------*/

package pj.io;

import pj.io.StoryContainer;

public class DownloadProgressNotification 
    {

    // --- Instance variables

    public StoryContainer source;     // The SC that sent the token
    public String         strSubsect; // The subsect of the SC
    public int            newState;   // The new state of the SC

    // --- Public constructor

    public DownloadProgressNotification( StoryContainer o, String subsect, int state )
        {
        source = o;
        strSubsect = subsect;
        newState = state;
        }

    }; // DownloadProgressNotification
