/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.



    @(#)MalformedPaperStoryException.java   0.00 20-Dec-95


        An exception that signals a PaperStory that is internally inconsistent


    Authors:

        rphall      Rick Hall


    Version Ident:

        $Header$


    History:

        12/20/95    rphall      Initial Creation


---------------------------------------------------------------------------*/

package pj.io;

/**
 * Signals that a malformed PaperStory has occurred.
 * @version 0.00, 20-Dec-95
 * @author 	Rick Hall
 */
public class MalformedPaperStoryException extends Exception
    {

    // --- Public constructors

    /**
     * Constructs a MalformedPaperStoryException with no detail message. 
     * A detail message is a String that describes this particular 
     * exception.
     */
    public MalformedPaperStoryException()
        {
        }

    /**
     * Constructs a MalformedPaperStoryException with the specified detail 
     * message.  A detail message is a String that describes this 
     * particular exception.
     * @param msg the detail message
     */
    public MalformedPaperStoryException(String msg)
        { 
        super(msg); 
        }

    } // MalformedPaperStoryException

