/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.



    @(#)StoryContainer.java	0.00    20-Dec-95


        Capabilities of a generic Container for PaperStories.


    Authors:

        rphall      Rick Hall


    Version Ident:

        $Header$


    History:

        12/20/95    rphall      Initial Creation


---------------------------------------------------------------------------*/

package pj.io;

import pj.io.IncompatiblePaperStoryException;
import pj.io.MalformedPaperStoryException;
import pj.io.PaperStory;

import collections.ImplementationError;
import java.lang.IllegalArgumentException;
import java.util.NoSuchElementException;

/**
 * Capabilities of a generic Container for PaperStories.
 * @version 0.00, 20-Dec-95
 * @author 	Rick Hall
 */
public interface StoryContainer
    {


    // --- Public operations

    public void addStory(PaperStory ps)
        throws MalformedPaperStoryException, IncompatiblePaperStoryException,
               IllegalArgumentException;

    public int numStories();

    public void removeStories();

    public PaperStory firstStory()
        throws NoSuchElementException;

    public PaperStory nextStory()
        throws NoSuchElementException;

    public PaperStory lastStory()
        throws NoSuchElementException;

    public PaperStory previousStory()
        throws NoSuchElementException;

    public PaperStory currentStory()
        throws NoSuchElementException;

    } // StoryContainer
