/*---------------------------------------------------------------------------

    Written by the Personal Journal developers of Dow Jones & Company, Inc.

    Dow Jones makes no representations or warranties about 
    the suitability of this software, either express or 
    implied, including but not limited to the implied warranties 
    of merchantability, fitness for a particular purpose, 
    or non-infringement.  Dow Jones will not be liable for 
    any damages suffered by a user as a result of using, 
    modifying or distributing this software or its derivatives.


    @(#)Nameable.java  0.00 04-Jan-96

        Nameable objects have a string attribute
        which may be set and retrieved.

    Authors:

        rphall   Rick Hall

    Version Ident:

        $Header:$

    History:

        0.00 04-Jan-96  rphall      Initial Creation

---------------------------------------------------------------------------*/

package pj.util;

import java.lang.String;

/**
 * Nameable objects have a string attribute which may be set and retrieved.
 *
 * @version 0.00 04-Jan-96
 * @author  rphall
*/
public interface Nameable
    {

    // --- Public operations

    /**
     * @param name  The name for an object.
    */
    public void setName(String name);

    /**
     * @return  The name of an object.
    */
    public String getName();

    } // Nameable
